/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"



/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.

   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it
   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.


   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/


extern rtx_insn *gen_split_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_split_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_1 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_2 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_3 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_4 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_5 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_6 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_7 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_8 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_9 (rtx_insn *, rtx *);
extern rtx_insn *gen_peephole2_10 (rtx_insn *, rtx *);




static int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !register_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !register_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern0 (x3); /* [-1, 1] */

    case E_DImode:
      if (pattern1 (x3, E_DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern1 (x3, E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern1 (x3, E_DFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern4 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern5 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return pattern4 (x3); /* [-1, 1] */
}

static int
pattern6 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern7 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern6 (x1, E_SImode); /* [-1, 1] */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern8 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !register_operand (operands[2], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !register_operand (operands[2], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_FCCmode)
      || GET_MODE (x1) != E_FCCmode)
    return -1;
  return pattern8 (); /* [-1, 1] */
}

static int
pattern10 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      return pattern7 (x3); /* [-1, 2] */

    case REG:
    case SUBREG:
      operands[2] = x5;
      res = pattern9 (x3);
      if (res >= 0)
        return res + 3; /* [3, 4] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_FCCmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_FCCmode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  return pattern8 (); /* [-1, 1] */
}

static int
pattern12 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      return pattern1 (x1, E_SFmode); /* [-1, 0] */

    case E_DFmode:
      if (pattern1 (x1, E_DFmode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1 (x1, E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1 (x1, E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern13 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MEM
      || GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH)
    return -1;
  return 0;
}

static int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arith_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

static int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern17 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!nonimmediate_operand (operands[1], E_SImode))
            return -1;
          return 0;

        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!nonimmediate_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!nonimmediate_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !nonimmediate_operand (operands[1], E_QImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

static int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

static int
pattern19 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != i1
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x5, 0);
  operands[3] = x9;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

static int
pattern20 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 1);
  switch (GET_CODE (x7))
    {
    case LABEL_REF:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      return pattern20 (); /* [-1, 1] */

    case PC:
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != LABEL_REF)
        return -1;
      x10 = XEXP (x8, 0);
      operands[0] = x10;
      res = pattern20 ();
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

static int
pattern22 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern22 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern22 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern24 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern25 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode)
              || !sle_operand (operands[2], E_SImode))
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode)
              || !sle_operand (operands[2], E_DImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !sle_operand (operands[2], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

static int
pattern26 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !uns_arith_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !symbolic_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !symbolic_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !reg_or_0_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !reg_or_0_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern30 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || !register_operand (operands[1], E_DImode)
      || !reg_or_0_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

static int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !arith_operand (operands[2], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode)
          || !arith_operand (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !arith_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern33 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  return 0;
}

static int
pattern34 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !register_operand (operands[0], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!non_volatile_mem_operand (operands[1], E_HImode))
    return -1;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode
      || !register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!non_volatile_mem_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

static int
pattern35 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern36 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  switch (XWINT (x8, 0))
    {
    case 64L:
      return pattern35 (x1, E_DImode, E_TImode); /* [-1, 0] */

    case 32L:
      if (pattern35 (x1, E_SImode, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern37 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern38 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern39 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !const_1_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern40 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern41 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern42 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern43 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern44 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[0], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern45 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[1], i1))
    return -1;
  return 0;
}

static int
pattern46 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern45 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern45 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern47 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern48 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern49 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern51 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern52 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern53 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern55 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x2, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern57 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern58 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_FCCmode
      || !register_operand (operands[1], E_FCCmode)
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern59 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern60 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern61 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern62 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !reg_or_0_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern63 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern62 (x1, E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern62 (x1, E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

static int
pattern64 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

static int
pattern65 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1))
    return -1;
  return 0;
}

static int
pattern66 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1))
    return -1;
  return 0;
}

static int
pattern67 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !scratch_operand (operands[6], i1))
    return -1;
  return 0;
}

static int
pattern68 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1))
    return -1;
  return 0;
}

static int
pattern69 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !reg_or_0_operand (operands[2], i1)
      || !reg_or_0_operand (operands[3], i1)
      || !reg_or_0_operand (operands[4], i1)
      || !reg_or_0_operand (operands[5], i1)
      || !scratch_operand (operands[7], i1)
      || !scratch_operand (operands[8], i1))
    return -1;
  return 0;
}

static int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 2);
  operands[3] = x6;
  switch (GET_CODE (x3))
    {
    case EQ:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern57 (x2, E_SImode))
            {
            case 0:
              if (!
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)))
                return -1;
              return 138; /* *seleqsi_using_si */

            case 1:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 325 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 142; /* *seleqsi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern57 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 140; /* *seleqdi_using_si */

            case 1:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 144; /* *seleqdi_using_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NE:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern57 (x2, E_SImode))
            {
            case 0:
              if (!
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)))
                return -1;
              return 139; /* *selnesi_using_si */

            case 1:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], SImode)
   != register_operand (operands[3], SImode)) && 
#line 325 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 143; /* *selnesi_using_di */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern57 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 141; /* *selnedi_using_si */

            case 1:
              if (!(
#line 1849 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(register_operand (operands[2], DImode)
   != register_operand (operands[3], DImode)) && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
                return -1;
              return 145; /* *selnedi_using_di */

            default:
              return -1;
            }

        case E_SFmode:
          if (pattern58 (x2, E_SFmode) != 0
              || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 146; /* *selsf */

        case E_DFmode:
          if (pattern58 (x2, E_DFmode) != 0
              || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 147; /* *seldf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  res = recog_1 (x1, insn, pnum_clobbers);
  if (res >= 0)
    return res;
  if (GET_CODE (x2) != PC)
    return -1;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!equality_operator (operands[1], E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_FCCmode))
    return -1;
  x6 = XEXP (x3, 1);
  switch (GET_CODE (x6))
    {
    case LABEL_REF:
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != PC)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!
#line 2385 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 223; /* *branch_fp_FCCmode */

    case PC:
      x7 = XEXP (x3, 2);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x9 = XEXP (x7, 0);
      operands[0] = x9;
      if (!
#line 2401 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
        return -1;
      return 224; /* *branch_fp_inverted_FCCmode */

    default:
      return -1;
    }
}

static int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != ABS)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  x9 = XEXP (x2, 1);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  x10 = XEXP (x2, 2);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  switch (GET_CODE (x3))
    {
    case GT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern59 (x2, E_SFmode) != 0
              || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 70; /* smaxasf3 */

        case E_DFmode:
          if (pattern59 (x2, E_DFmode) != 0
              || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 71; /* smaxadf3 */

        default:
          return -1;
        }

    case LT:
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern59 (x2, E_SFmode) != 0
              || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 72; /* sminasf3 */

        case E_DFmode:
          if (pattern59 (x2, E_DFmode) != 0
              || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 73; /* sminadf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const_int_operand (operands[1], E_SImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[2] = x5;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x1, 1);
  operands[3] = x6;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !reg_or_0_operand (operands[3], E_SImode)
          || !
#line 1547 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))))
        return -1;
      return 124; /* *insvsi */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || !reg_or_0_operand (operands[3], E_DImode)
          || !(
#line 1547 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[0], INTVAL (operands[1]),
			    INTVAL (operands[2]))) && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
        return -1;
      return 125; /* *insvdi */

    default:
      return -1;
    }
}

static int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !move_operand (operands[1], E_DImode))
        return -1;
      if (
#line 1581 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return 126; /* *movdi_32bit */
      if (!
#line 1591 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && (register_operand (operands[0], DImode)
       || reg_or_0_operand (operands[1], DImode))))
        return -1;
      return 127; /* *movdi_64bit */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !move_operand (operands[1], E_SImode)
          || !
#line 1612 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))))
        return -1;
      return 128; /* *movsi_internal */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !move_operand (operands[1], E_HImode)
          || !
#line 1637 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], HImode)
       || reg_or_0_operand (operands[1], HImode))))
        return -1;
      return 129; /* *movhi_internal */

    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !move_operand (operands[1], E_QImode)
          || !
#line 1662 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
((register_operand (operands[0], QImode)
       || reg_or_0_operand (operands[1], QImode))))
        return -1;
      return 130; /* *movqi_internal */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !move_operand (operands[1], E_SFmode))
        return -1;
      if (
#line 1682 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return 131; /* *movsf_hardfloat */
      if (!
#line 1692 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_SOFT_FLOAT
   && (register_operand (operands[0], SFmode)
       || reg_or_0_operand (operands[1], SFmode))))
        return -1;
      return 132; /* *movsf_softfloat */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !move_operand (operands[1], E_DFmode))
        return -1;
      if (
#line 1713 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return 133; /* *movdf_hardfloat */
      if (!
#line 1723 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
((TARGET_SOFT_FLOAT || TARGET_SINGLE_FLOAT)
   && (register_operand (operands[0], DFmode)
       || reg_or_0_operand (operands[1], DFmode))))
        return -1;
      return 134; /* *movdf_softfloat */

    case E_TImode:
      if (!nonimmediate_operand (operands[0], E_TImode)
          || !move_operand (operands[1], E_TImode)
          || !
#line 1745 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && (register_operand (operands[0], TImode)
       || reg_or_0_operand (operands[1], TImode))))
        return -1;
      return 135; /* *movti */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !move_operand (operands[1], E_TFmode)
          || !
#line 1770 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && (register_operand (operands[0], TFmode)
       || reg_or_0_operand (operands[1], TFmode))))
        return -1;
      return 136; /* *movtf */

    default:
      return -1;
    }
}

static int
recog_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      switch (XINT (x2, 1))
        {
        case 8:
          switch (pattern27 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 150; /* frint_s */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 151; /* frint_d */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (!register_operand (operands[0], E_DFmode)
                  || GET_MODE (x2) != E_DFmode
                  || !general_operand (operands[1], E_SImode)
                  || !(
#line 1940 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 362 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 152; /* load_lowdf */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !general_operand (operands[1], E_SImode)
                  || !(
#line 1940 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 363 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 153; /* load_lowdi */

            case E_TFmode:
              if (!register_operand (operands[0], E_TFmode)
                  || GET_MODE (x2) != E_TFmode
                  || !general_operand (operands[1], E_DImode)
                  || !(
#line 1940 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 154; /* load_lowtf */

            default:
              return -1;
            }

        case 15:
          switch (pattern28 (x2))
            {
            case 0:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 161; /* got_load_tls_gdsi */

            case 1:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 162; /* got_load_tls_gddi */

            default:
              return -1;
            }

        case 16:
          switch (pattern28 (x2))
            {
            case 0:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 163; /* got_load_tls_ldsi */

            case 1:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 164; /* got_load_tls_lddi */

            default:
              return -1;
            }

        case 17:
          switch (pattern28 (x2))
            {
            case 0:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 165; /* got_load_tls_lesi */

            case 1:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 166; /* got_load_tls_ledi */

            default:
              return -1;
            }

        case 18:
          switch (pattern28 (x2))
            {
            case 0:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 167; /* got_load_tls_iesi */

            case 1:
              if (!
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 168; /* got_load_tls_iedi */

            default:
              return -1;
            }

        case 7:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode))
                return -1;
              switch (pattern41 (x2))
                {
                case 0:
                  if (!(
#line 2037 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 362 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 172; /* movfrh2grdf */

                case 1:
                  if (!(
#line 2037 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 363 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 173; /* movfrh2grdi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 2037 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 174; /* movfrh2grtf */

            default:
              return -1;
            }

        case 0:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 220; /* revb_2h */

        case 1:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 221; /* revb_4h */

        case 2:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode)
              || !
#line 2364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 222; /* revh_d */

        case 9:
          switch (pattern27 (x2))
            {
            case 0:
              if (!
#line 3241 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 316; /* fclass_s */

            case 1:
              if (!(
#line 3241 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 317; /* fclass_d */

            default:
              return -1;
            }

        case 13:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 320; /* bitrev_4b */

        case 14:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || !register_operand (operands[1], E_DImode))
            return -1;
          return 321; /* bitrev_8b */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern42 (x2, E_DFmode, E_SImode) != 0
                  || !(
#line 1955 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 362 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 155; /* load_highdf */

            case E_DImode:
              if (pattern42 (x2, E_DImode, E_SImode) != 0
                  || !(
#line 1955 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 363 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 156; /* load_highdi */

            case E_TFmode:
              if (pattern42 (x2, E_TFmode, E_DImode) != 0
                  || !(
#line 1955 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 157; /* load_hightf */

            default:
              return -1;
            }

        case 5:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!nonimmediate_operand (operands[0], E_SImode))
                return -1;
              switch (pattern41 (x2))
                {
                case 0:
                  if (!(
#line 1970 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 362 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 158; /* store_worddf */

                case 1:
                  if (!(
#line 1970 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 363 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 159; /* store_worddi */

                default:
                  return -1;
                }

            case E_DImode:
              if (!nonimmediate_operand (operands[0], E_DImode)
                  || GET_MODE (x2) != E_DImode
                  || !register_operand (operands[1], E_TFmode)
                  || !(
#line 1970 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT) && 
#line 364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 160; /* store_wordtf */

            default:
              return -1;
            }

        case 6:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          x4 = XVECEXP (x2, 0, 0);
          operands[1] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DFmode:
              if (pattern43 (x2, E_DFmode, E_SImode) != 0
                  || !(
#line 2027 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 362 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 169; /* movgr2frhdf */

            case E_DImode:
              if (pattern43 (x2, E_DImode, E_SImode) != 0
                  || !(
#line 2027 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 363 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 170; /* movgr2frhdi */

            case E_TFmode:
              if (pattern43 (x2, E_TFmode, E_DImode) != 0
                  || !(
#line 2027 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT) && 
#line 364 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT && TARGET_DOUBLE_FLOAT)))
                return -1;
              return 171; /* movgr2frhtf */

            default:
              return -1;
            }

        case 19:
          if (GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != MEM
              || GET_MODE (x3) != E_BLKmode)
            return -1;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != SCRATCH)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x2, 0, 1);
          operands[1] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 322; /* stack_tiesi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 323; /* stack_tiedi */

            default:
              return -1;
            }

        case 20:
          switch (pattern18 (x1))
            {
            case 0:
              return 330; /* loongarch_crc_w_b_w */

            case 1:
              return 331; /* loongarch_crc_w_h_w */

            case 2:
              return 332; /* loongarch_crc_w_w_w */

            case 3:
              return 333; /* loongarch_crc_w_d_w */

            default:
              return -1;
            }

        case 21:
          switch (pattern18 (x1))
            {
            case 0:
              return 334; /* loongarch_crcc_w_b_w */

            case 1:
              return 335; /* loongarch_crcc_w_h_w */

            case 2:
              return 336; /* loongarch_crcc_w_w_w */

            case 3:
              return 337; /* loongarch_crcc_w_d_w */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      x7 = XVECEXP (x2, 0, 2);
      operands[3] = x7;
      switch (XINT (x2, 1))
        {
        case 11:
          if (pattern44 (x2, E_SImode) != 0
              || !const_0_to_3_operand (operands[3], E_SImode))
            return -1;
          return 318; /* bytepick_w */

        case 12:
          if (pattern44 (x2, E_DImode) != 0
              || !const_0_to_7_operand (operands[3], E_DImode))
            return -1;
          return 319; /* bytepick_d */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case FMA:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case NEG:
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern53 (x3, E_SFmode) != 0
                      || !(
#line 854 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 46; /* *fmasf4 */

                case E_DFmode:
                  if (pattern53 (x3, E_DFmode) != 0
                      || !(
#line 854 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 47; /* *fmadf4 */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern54 (x3, E_SFmode) != 0
                      || !(
#line 867 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 48; /* *fmssf4 */

                case E_DFmode:
                  if (pattern54 (x3, E_DFmode) != 0
                      || !(
#line 867 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 49; /* *fmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x6;
          x8 = XEXP (x4, 2);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
              operands[3] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern55 (x3, E_SFmode) != 0
                      || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 50; /* *fnmssf4 */

                case E_DFmode:
                  if (pattern55 (x3, E_DFmode) != 0
                      || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 51; /* *fnmsdf4 */

                default:
                  return -1;
                }

            case NEG:
              x9 = XEXP (x8, 0);
              operands[3] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern56 (x3, E_SFmode) != 0
                      || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                    return -1;
                  return 52; /* *fnmasf4 */

                case E_DFmode:
                  if (pattern56 (x3, E_DFmode) != 0
                      || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                    return -1;
                  return 53; /* *fnmadf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 74; /* negsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 75; /* negdi2 */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !register_operand (operands[1], E_SFmode)
              || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 78; /* negsf2 */

        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_DFmode)
              || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 79; /* negdf2 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      switch (XINT (x3, 1))
        {
        case 15:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 177; /* loongarch_cpucfg */

        case 13:
          if (!const_uimm5_operand (operands[1], E_VOIDmode)
              || !
#line 3226 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 314; /* loongarch_movfcsr2gr */

        default:
          return -1;
        }

    case 3:
      if (XINT (x3, 1) != 12)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 2);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern52 (x3, E_SImode) != 0
              || !
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return -1;
          return 298; /* probe_stack_rangesi */

        case E_DImode:
          if (pattern52 (x3, E_DImode) != 0
              || !
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return -1;
          return 299; /* probe_stack_rangedi */

        default:
          return -1;
        }

    case 2:
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 31:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!memory_operand (operands[0], E_SImode)
                  || GET_MODE (x3) != E_SImode
                  || !reg_or_0_operand (operands[1], E_SImode))
                return -1;
              return 339; /* atomic_storesi */

            case E_DImode:
              if (!memory_operand (operands[0], E_DImode)
                  || GET_MODE (x3) != E_DImode
                  || !reg_or_0_operand (operands[1], E_DImode)
                  || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 340; /* atomic_storedi */

            default:
              return -1;
            }

        case 29:
          x4 = XVECEXP (x3, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern46 (x3))
                {
                case 0:
                  return 341; /* atomic_addsi */

                case 1:
                  if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 345; /* atomic_adddi */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern46 (x3))
                {
                case 0:
                  return 342; /* atomic_orsi */

                case 1:
                  if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 346; /* atomic_ordi */

                default:
                  return -1;
                }

            case XOR:
              switch (pattern46 (x3))
                {
                case 0:
                  return 343; /* atomic_xorsi */

                case 1:
                  if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 347; /* atomic_xordi */

                default:
                  return -1;
                }

            case AND:
              switch (pattern46 (x3))
                {
                case 0:
                  return 344; /* atomic_andsi */

                case 1:
                  if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 348; /* atomic_anddi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          if (register_operand (operands[1], E_SImode)
              && uns_arith_operand (operands[2], E_SImode))
            return 80; /* andsi3 */
          if (!nonimmediate_operand (operands[1], E_SImode)
              || !low_bitmask_operand (operands[2], E_SImode))
            return -1;
          return 86; /* andsi3_extended */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          if (register_operand (operands[1], E_DImode)
              && uns_arith_operand (operands[2], E_DImode)
              && 
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return 83; /* anddi3 */
          if (!nonimmediate_operand (operands[1], E_DImode)
              || !low_bitmask_operand (operands[2], E_DImode)
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 87; /* anddi3_extended */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NOT:
          x7 = XEXP (x5, 0);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern40 (x3, E_SImode) != 0)
                return -1;
              return 89; /* *norsi3 */

            case E_DImode:
              if (pattern40 (x3, E_DImode) != 0
                  || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 90; /* *nordi3 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern23 (x3))
            {
            case 0:
              return 91; /* andnsi */

            case 1:
              if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 93; /* andndi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern16 (x3, E_DImode) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!const_immalsl_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_VOIDmode)
          || !
#line 2284 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && ((INTVAL (operands[3]) >> INTVAL (operands[2])) == 0xffffffff)))
        return -1;
      return 213; /* zero_extend_ashift */

    default:
      return -1;
    }
}

static int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern1 (x3, E_SFmode) != 0
                  || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 2; /* addsf3 */

            case E_DFmode:
              if (pattern1 (x3, E_DFmode) != 0
                  || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 3; /* adddf3 */

            case E_SImode:
              if (pattern32 (x3, E_SImode) != 0)
                return -1;
              return 4; /* addsi3 */

            case E_DImode:
              if (pattern32 (x3, E_DImode) != 0
                  || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 5; /* adddi3 */

            default:
              return -1;
            }

        case AND:
          if (GET_MODE (x5) != E_DImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != ASHIFT
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!const_immalsl_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x5, 1);
          operands[4] = x9;
          if (!immediate_operand (operands[4], E_VOIDmode)
              || !
#line 2297 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT
   && ((INTVAL (operands[4]) >> INTVAL (operands[3])) == 0xffffffff)))
            return -1;
          return 214; /* bstrpick_alsl_paired */

        default:
          return -1;
        }

    case ASHIFT:
      x10 = XEXP (x4, 0);
      operands[1] = x10;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      if (!const_immalsl_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern47 (x3, E_SImode) != 0)
            return -1;
          return 215; /* alslsi3 */

        case E_DImode:
          if (pattern47 (x3, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 216; /* alsldi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern48 (x3, E_SFmode) != 0
                  || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 38; /* fmasf4 */

            case E_DFmode:
              if (pattern48 (x3, E_DFmode) != 0
                  || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 39; /* fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern49 (x3, E_SFmode) != 0
                  || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 40; /* fmssf4 */

            case E_DFmode:
              if (pattern49 (x3, E_DFmode) != 0
                  || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 41; /* fmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      x6 = XEXP (x3, 2);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern50 (x3, E_SFmode) != 0
                  || !(
#line 823 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 42; /* fnmasf4 */

            case E_DFmode:
              if (pattern50 (x3, E_DFmode) != 0
                  || !(
#line 823 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 43; /* fnmadf4 */

            default:
              return -1;
            }

        case NEG:
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern51 (x3, E_SFmode) != 0
                  || !(
#line 841 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (SFmode)) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 44; /* fnmssf4 */

            case E_DFmode:
              if (pattern51 (x3, E_DFmode) != 0
                  || !(
#line 841 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!HONOR_SIGNED_ZEROS (DFmode)) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 45; /* fnmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case PLUS:
      if (pattern15 (x3) != 0
          || !
#line 550 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 6; /* *addsi3_extended */

    case MINUS:
      if (GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!reg_or_0_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 588 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 11; /* *subsi3_extended */

    case MULT:
      if (pattern16 (x3, E_SImode) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 633 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 17; /* *mulsi3_extended */

    case REG:
    case SUBREG:
    case MEM:
      switch (pattern17 (x3))
        {
        case 0:
          if (!
#line 1232 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 107; /* extendsidi2 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 109; /* extendqidi2 */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 111; /* extendhidi2 */

        case 3:
          return 108; /* extendqisi2 */

        case 4:
          return 110; /* extendhisi2 */

        case 5:
          return 112; /* extendqihi2 */

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern15 (x3) != 0
          || !
#line 2252 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 208; /* *ashlsi3_extend */

    case ASHIFTRT:
      if (pattern15 (x3) != 0
          || !
#line 2252 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 209; /* *ashrsi3_extend */

    case LSHIFTRT:
      if (pattern15 (x3) != 0
          || !
#line 2252 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 210; /* *lshrsi3_extend */

    default:
      return -1;
    }
}

static int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern17 (x3))
        {
        case 0:
          if (!
#line 1154 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 96; /* *zero_extendsidi2_internal */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 98; /* zero_extendqidi2 */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 100; /* zero_extendhidi2 */

        case 3:
          return 97; /* zero_extendqisi2 */

        case 4:
          return 99; /* zero_extendhisi2 */

        case 5:
          return 101; /* zero_extendqihi2 */

        default:
          return -1;
        }

    case TRUNCATE:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x3) != E_SImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1207 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 102; /* *zero_extendsi_truncqi */

            case E_HImode:
              if (!
#line 1207 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 104; /* *zero_extendsi_trunchi */

            default:
              return -1;
            }

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!
#line 1207 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 103; /* *zero_extenddi_truncqi */

            case E_HImode:
              if (!
#line 1207 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 105; /* *zero_extenddi_trunchi */

            default:
              return -1;
            }

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !
#line 1216 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 106; /* *zero_extendhi_truncqi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_14 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern26 (x3, E_SImode) != 0)
            return -1;
          return 81; /* iorsi3 */

        case E_DImode:
          if (pattern26 (x3, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 84; /* iordi3 */

        case E_HImode:
          if (pattern26 (x3, E_HImode) != 0)
            return -1;
          return 88; /* *iorhi3 */

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      switch (pattern23 (x3))
        {
        case 0:
          return 92; /* iornsi */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 94; /* iorndi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SUBREG
          || maybe_ne (SUBREG_BYTE (x6), 0)
          || GET_MODE (x6) != E_SImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!const_lu32i_operand (operands[2], E_DImode)
          || !
#line 1909 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 148; /* lu32i_d */

    case AND:
      if (pattern16 (x3, E_DImode) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      if (!lu52i_mask_operand (operands[2], E_VOIDmode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!const_lu52i_operand (operands[3], E_VOIDmode)
          || !
#line 1920 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 149; /* lu52i_d */

    default:
      return -1;
    }
}

static int
recog_15 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern1 (x3, E_SFmode) != 0
              || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 22; /* *divsf3 */

        case E_DFmode:
          if (pattern1 (x3, E_DFmode) != 0
              || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 23; /* *divdf3 */

        case E_SImode:
          switch (pattern0 (x3))
            {
            case 0:
              return 26; /* *divsi3 */

            case 1:
              return 34; /* divdi3_fake */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern1 (x3, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 30; /* *divdi3 */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern38 (x3, E_SFmode) != 0
                  || !
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 24; /* *recipsf3 */

            case E_DFmode:
              if (pattern38 (x3, E_DFmode) != 0
                  || !
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 25; /* *recipdf3 */

            default:
              return -1;
            }

        case SQRT:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern39 (x3, E_SFmode) != 0
                  || !(
#line 918 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 56; /* *rsqrtsfa */

            case E_DFmode:
              if (pattern39 (x3, E_DFmode) != 0
                  || !(
#line 918 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 57; /* *rsqrtdfa */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
      x4 = XEXP (x3, 1);
      if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
        {
          res = recog_2 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!equality_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 229; /* branch_equalitysi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 230; /* branch_equalitydi */

        case 2:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 231; /* *branch_equalitysi_inverted */

        case 3:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 232; /* *branch_equalitydi_inverted */

        default:
          return -1;
        }

    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      x5 = XEXP (x3, 0);
      if (GET_CODE (x5) == ABS)
        {
          res = recog_3 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x3;
      if (!order_operator (operands[1], E_VOIDmode))
        return -1;
      switch (pattern21 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 225; /* *branch_ordersi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 226; /* *branch_orderdi */

        case 2:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 227; /* *branch_ordersi_inverted */

        case 3:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 228; /* *branch_orderdi_inverted */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

static int
recog_17 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern12 (x3))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 12; /* mulsf3 */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 13; /* muldf3 */

        case 2:
          return 14; /* mulsi3 */

        case 3:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 15; /* muldi3 */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != SIGN_EXTEND
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode)
          || !
#line 623 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
        return -1;
      return 16; /* mulsidi3_64bit */

    default:
      return -1;
    }
}

static int
recog_18 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case ZERO_EXTRACT:
      res = recog_4 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case REG:
    case SUBREG:
    case MEM:
      res = recog_5 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case PC:
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && 
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
            return 293; /* indirect_jumpsi */
          break;

        case E_DImode:
          if (register_operand (operands[0], E_DImode)
              && 
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
            return 294; /* indirect_jumpdi */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
      if (XWINT (x3, 0) != 0L)
        return -1;
      operands[0] = x2;
      if (!register_operand (operands[0], E_FCCmode))
        return -1;
      return 137; /* movfcc */

    case LABEL_REF:
      if (GET_CODE (x2) != PC)
        return -1;
      x4 = XEXP (x3, 0);
      operands[0] = x4;
      if (
#line 2610 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!flag_pic))
        return 291; /* *jump_absolute */
      if (!
#line 2619 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(flag_pic))
        return -1;
      return 292; /* *jump_pic */

    default:
      return -1;
    }
}

static int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case UNSPEC_VOLATILE:
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      switch (XVECLEN (x3, 0))
        {
        case 1:
          if (pattern33 (x1) != 0)
            return -1;
          switch (XINT (x3, 1))
            {
            case 3:
              if (!const_uimm14_operand (operands[1], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 182; /* loongarch_csrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 183; /* loongarch_csrrd_d */

                default:
                  return -1;
                }

            case 6:
              if (!register_operand (operands[1], E_SImode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_QImode:
                  if (!register_operand (operands[0], E_QImode)
                      || GET_MODE (x3) != E_QImode)
                    return -1;
                  return 188; /* loongarch_iocsrrd_b */

                case E_HImode:
                  if (!register_operand (operands[0], E_HImode)
                      || GET_MODE (x3) != E_HImode)
                    return -1;
                  return 189; /* loongarch_iocsrrd_h */

                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode)
                    return -1;
                  return 190; /* loongarch_iocsrrd_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !
#line 354 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 191; /* loongarch_iocsrrd_d */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[1] = x5;
          switch (XINT (x3, 1))
            {
            case 4:
              x6 = XVECEXP (x1, 0, 1);
              if (pattern14 (x6) != 0)
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[2] = x7;
              if (!const_uimm14_operand (operands[2], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || GET_MODE (x3) != E_SImode
                      || !register_operand (operands[1], E_SImode))
                    return -1;
                  return 184; /* loongarch_csrwr_w */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || GET_MODE (x3) != E_DImode
                      || !register_operand (operands[1], E_DImode)
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 185; /* loongarch_csrwr_d */

                default:
                  return -1;
                }

            case 30:
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) != SET)
                return -1;
              x7 = XVECEXP (x3, 0, 1);
              operands[3] = x7;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern61 (x3, E_SImode) != 0)
                    return -1;
                  return 357; /* atomic_exchangesi */

                case E_DImode:
                  if (pattern61 (x3, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 358; /* atomic_exchangedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 3:
          if (XINT (x3, 1) != 5
              || pattern33 (x1) != 0)
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[2] = x7;
          x10 = XVECEXP (x3, 0, 2);
          operands[3] = x10;
          if (!const_uimm14_operand (operands[3], E_VOIDmode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern64 (x3, E_SImode) != 0)
                return -1;
              return 186; /* loongarch_csrxchg_w */

            case E_DImode:
              if (pattern64 (x3, E_DImode) != 0
                  || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 187; /* loongarch_csrxchg_d */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PC:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != USE)
            return -1;
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != LABEL_REF)
            return -1;
          operands[0] = x3;
          x11 = XEXP (x9, 0);
          operands[1] = x11;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (!register_operand (operands[0], E_SImode)
                  || !
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == SImode))
                return -1;
              return 295; /* tablejumpsi */

            case E_DImode:
              if (!register_operand (operands[0], E_DImode)
                  || !
#line 336 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(Pmode == DImode))
                return -1;
              return 296; /* tablejumpdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
        case MEM:
          operands[0] = x4;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          operands[1] = x3;
          x8 = XEXP (x6, 1);
          switch (GET_CODE (x8))
            {
            case REG:
            case SUBREG:
            case MEM:
              operands[3] = x8;
              x9 = XEXP (x6, 0);
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_HImode:
                  if (pattern60 (E_HImode) != 0
                      || !
#line 3310 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
                    return -1;
                  return 324; /* *join2_load_storehi */

                case E_SImode:
                  if (pattern60 (E_SImode) != 0
                      || !
#line 3310 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
                    return -1;
                  return 325; /* *join2_load_storesi */

                case E_SFmode:
                  if (pattern60 (E_SFmode) != 0
                      || !(
#line 3310 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 331 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                    return -1;
                  return 326; /* *join2_load_storesf */

                case E_DFmode:
                  if (pattern60 (E_DFmode) != 0
                      || !(
#line 3310 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed) && 
#line 332 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                    return -1;
                  return 327; /* *join2_load_storedf */

                default:
                  return -1;
                }

            case UNSPEC_VOLATILE:
              x9 = XEXP (x6, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x8, 0))
                {
                case 2:
                  if (XINT (x8, 1) != 29)
                    return -1;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  if (!const_int_operand (operands[3], E_SImode))
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  switch (GET_CODE (x13))
                    {
                    case PLUS:
                      switch (pattern63 (x8))
                        {
                        case 0:
                          return 349; /* atomic_fetch_addsi */

                        case 1:
                          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 353; /* atomic_fetch_adddi */

                        default:
                          return -1;
                        }

                    case IOR:
                      switch (pattern63 (x8))
                        {
                        case 0:
                          return 350; /* atomic_fetch_orsi */

                        case 1:
                          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 354; /* atomic_fetch_ordi */

                        default:
                          return -1;
                        }

                    case XOR:
                      switch (pattern63 (x8))
                        {
                        case 0:
                          return 351; /* atomic_fetch_xorsi */

                        case 1:
                          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 355; /* atomic_fetch_xordi */

                        default:
                          return -1;
                        }

                    case AND:
                      switch (pattern63 (x8))
                        {
                        case 0:
                          return 352; /* atomic_fetch_andsi */

                        case 1:
                          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 356; /* atomic_fetch_anddi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 4:
                  if (pnum_clobbers == NULL
                      || XINT (x8, 1) != 22)
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  operands[2] = x13;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  x14 = XVECEXP (x8, 0, 2);
                  operands[4] = x14;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x15 = XVECEXP (x8, 0, 3);
                  operands[5] = x15;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern65 (x8, E_SImode) != 0)
                        return -1;
                      *pnum_clobbers = 1;
                      return 359; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern65 (x8, E_DImode) != 0
                          || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      *pnum_clobbers = 1;
                      return 360; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  if (pnum_clobbers == NULL)
                    return -1;
                  x13 = XVECEXP (x8, 0, 0);
                  operands[2] = x13;
                  x12 = XVECEXP (x8, 0, 1);
                  operands[3] = x12;
                  x14 = XVECEXP (x8, 0, 2);
                  operands[4] = x14;
                  x15 = XVECEXP (x8, 0, 3);
                  operands[5] = x15;
                  x16 = XVECEXP (x8, 0, 4);
                  operands[6] = x16;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  switch (XINT (x8, 1))
                    {
                    case 22:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 1;
                          return 361; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 1;
                          return 362; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 23:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 363; /* atomic_cas_value_add_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 364; /* atomic_cas_value_add_7_di */

                        default:
                          return -1;
                        }

                    case 24:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 365; /* atomic_cas_value_sub_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 366; /* atomic_cas_value_sub_7_di */

                        default:
                          return -1;
                        }

                    case 25:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 367; /* atomic_cas_value_and_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 368; /* atomic_cas_value_and_7_di */

                        default:
                          return -1;
                        }

                    case 26:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 369; /* atomic_cas_value_xor_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 370; /* atomic_cas_value_xor_7_di */

                        default:
                          return -1;
                        }

                    case 27:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 371; /* atomic_cas_value_or_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 372; /* atomic_cas_value_or_7_di */

                        default:
                          return -1;
                        }

                    case 28:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 2;
                          return 373; /* atomic_cas_value_nand_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 2;
                          return 374; /* atomic_cas_value_nand_7_di */

                        default:
                          return -1;
                        }

                    case 30:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern66 (x8, E_SImode) != 0)
                            return -1;
                          *pnum_clobbers = 1;
                          return 375; /* atomic_cas_value_exchange_7_si */

                        case E_DImode:
                          if (pattern66 (x8, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          *pnum_clobbers = 1;
                          return 376; /* atomic_cas_value_exchange_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case CALL:
      x17 = XEXP (x3, 0);
      if (GET_CODE (x17) != MEM
          || GET_MODE (x17) != E_SImode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x18 = XEXP (x17, 0);
      operands[1] = x18;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x19 = XEXP (x3, 1);
      operands[2] = x19;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != CALL)
            return -1;
          x20 = XEXP (x8, 0);
          if (GET_CODE (x20) != MEM
              || GET_MODE (x20) != E_SImode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_VOIDmode))
            return -1;
          x21 = XEXP (x20, 0);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          x22 = XEXP (x8, 1);
          if (!rtx_equal_p (x22, operands[2]))
            return -1;
          if (
#line 2957 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
            return 309; /* sibcall_value_multiple_internal */
          if (pnum_clobbers == NULL)
            return -1;
          *pnum_clobbers = 1;
          return 312; /* call_value_multiple_internal */

        case CLOBBER:
          x9 = XEXP (x6, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 1
              || GET_MODE (x9) != E_SImode)
            return -1;
          return 311; /* call_value_internal */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern19 (x1, SIGN_EXTEND) != 0
          || !
#line 3356 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 328; /* *join2_loadhi */

    case ZERO_EXTEND:
      if (pattern19 (x1, ZERO_EXTEND) != 0
          || !
#line 3356 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
        return -1;
      return 329; /* *join2_loadhi */

    case UNSPEC:
      if (XVECLEN (x3, 0) != 1
          || XINT (x3, 1) != 32
          || GET_MODE (x3) != E_BLKmode)
        return -1;
      x4 = XEXP (x2, 0);
      operands[0] = x4;
      x6 = XVECEXP (x1, 0, 1);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      return 338; /* mem_thread_fence_1 */

    default:
      return -1;
    }
}

static int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      return recog_10 (x1, insn, pnum_clobbers);

    case SIGN_EXTEND:
      return recog_12 (x1, insn, pnum_clobbers);

    case MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern12 (x2))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 7; /* subsf3 */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 8; /* subdf3 */

        case 2:
          return 9; /* subsi3 */

        case 3:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 10; /* subdi3 */

        default:
          return -1;
        }

    case MULT:
      return recog_17 (x1, insn, pnum_clobbers);

    case TRUNCATE:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != LSHIFTRT)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != MULT)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern36 (x2, SIGN_EXTEND))
            {
            case 0:
              if (!
#line 672 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 18; /* muldi3_highpart */

            case 1:
              if (!
#line 702 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 20; /* mulsi3_highpart */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern36 (x2, ZERO_EXTEND))
            {
            case 0:
              if (!
#line 672 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 19; /* umuldi3_highpart */

            case 1:
              if (!
#line 702 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 21; /* umulsi3_highpart */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case DIV:
      return recog_15 (x1, insn, pnum_clobbers);

    case UDIV:
      switch (pattern2 (x1))
        {
        case 0:
          return 27; /* *udivsi3 */

        case 1:
          return 35; /* udivdi3_fake */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 31; /* *udivdi3 */

        default:
          return -1;
        }

    case MOD:
      switch (pattern2 (x1))
        {
        case 0:
          return 28; /* *modsi3 */

        case 1:
          return 36; /* moddi3_fake */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 32; /* *moddi3 */

        default:
          return -1;
        }

    case UMOD:
      switch (pattern2 (x1))
        {
        case 0:
          return 29; /* *umodsi3 */

        case 1:
          return 37; /* umoddi3_fake */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 33; /* *umoddi3 */

        default:
          return -1;
        }

    case FMA:
      return recog_11 (x1, insn, pnum_clobbers);

    case NEG:
      return recog_7 (x1, insn, pnum_clobbers);

    case SQRT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          switch (pattern13 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 54; /* sqrtsf2 */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 55; /* sqrtdf2 */

            default:
              return -1;
            }

        case DIV:
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern37 (x2, E_SFmode) != 0
                  || !(
#line 928 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 58; /* *rsqrtsfb */

            case E_DFmode:
              if (pattern37 (x2, E_DFmode) != 0
                  || !(
#line 928 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(flag_unsafe_math_optimizations) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 59; /* *rsqrtdfb */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ABS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern13 (x2))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 60; /* abssf2 */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 61; /* absdf2 */

        default:
          return -1;
        }

    case CLZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 62; /* clzsi2 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 63; /* clzdi2 */

        default:
          return -1;
        }

    case CTZ:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 64; /* ctzsi2 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 65; /* ctzdi2 */

        default:
          return -1;
        }

    case SMAX:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 66; /* smaxsf3 */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 67; /* smaxdf3 */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern3 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 68; /* sminsf3 */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 69; /* smindf3 */

        default:
          return -1;
        }

    case IF_THEN_ELSE:
      return recog_16 (x1, insn, pnum_clobbers);

    case NOT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern4 (x2))
        {
        case 0:
          return 76; /* one_cmplsi2 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 77; /* one_cmpldi2 */

        default:
          return -1;
        }

    case AND:
      return recog_9 (x1, insn, pnum_clobbers);

    case IOR:
      return recog_14 (x1, insn, pnum_clobbers);

    case XOR:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern26 (x2, E_SImode) != 0)
            return -1;
          return 82; /* xorsi3 */

        case E_DImode:
          if (pattern26 (x2, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 85; /* xordi3 */

        default:
          return -1;
        }

    case FLOAT_TRUNCATE:
      if (GET_MODE (x2) != E_SFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_SFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 1133 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 95; /* truncdfsf2 */

    case ZERO_EXTEND:
      return recog_13 (x1, insn, pnum_clobbers);

    case FLOAT_EXTEND:
      if (GET_MODE (x2) != E_DFmode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DFmode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 1268 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
        return -1;
      return 113; /* extendsfdf2 */

    case FIX:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern24 (x2, E_SImode))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 114; /* fix_truncsfsi2 */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 116; /* fix_truncdfsi2 */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern24 (x2, E_DImode))
            {
            case 0:
              if (!(
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
                return -1;
              return 115; /* fix_truncsfdi2 */

            case 1:
              if (!(
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
                return -1;
              return 117; /* fix_truncdfdi2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case FLOAT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          switch (pattern6 (x2, E_DFmode))
            {
            case 0:
              if (!
#line 1296 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 118; /* floatsidf2 */

            case 1:
              if (!
#line 1305 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 119; /* floatdidf2 */

            default:
              return -1;
            }

        case E_SFmode:
          switch (pattern6 (x2, E_SFmode))
            {
            case 0:
              if (!
#line 1314 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 120; /* floatsisf2 */

            case 1:
              if (!
#line 1323 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 121; /* floatdisf2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x2, 2);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      switch (pattern4 (x2))
        {
        case 0:
          if (!(
#line 1521 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT)))
            return -1;
          return 122; /* *extzvsi */

        case 1:
          if (!(
#line 1521 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_use_ins_ext_p (operands[1], INTVAL (operands[2]),
			    INTVAL (operands[3]))) && 
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT)))
            return -1;
          return 123; /* *extzvdi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      return recog_18 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_6 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      return recog_8 (x1, insn, pnum_clobbers);

    case ASHIFT:
      switch (pattern5 (x1))
        {
        case 0:
          return 202; /* ashlsi3 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 205; /* ashldi3 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 203; /* ashrsi3 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 206; /* ashrdi3 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern5 (x1))
        {
        case 0:
          return 204; /* lshrsi3 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 207; /* lshrdi3 */

        default:
          return -1;
        }

    case ROTATERT:
      switch (pattern5 (x1))
        {
        case 0:
          return 211; /* rotrsi3 */

        case 1:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 212; /* rotrdi3 */

        default:
          return -1;
        }

    case BSWAP:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || !register_operand (operands[1], E_HImode))
            return -1;
          return 217; /* bswaphi2 */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          return 218; /* bswapsi2 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 2339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 219; /* bswapdi2 */

        default:
          return -1;
        }

    case EQ:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 233; /* *seq_zero_sisi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 234; /* *seq_zero_disi */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 235; /* *seq_zero_didi */

        case 3:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 267; /* seq_sf_using_FCCmode */

        case 4:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 281; /* seq_df_using_FCCmode */

        default:
          return -1;
        }

    case NE:
      switch (pattern10 (x1))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 236; /* *sne_zero_sisi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 237; /* *sne_zero_disi */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 238; /* *sne_zero_didi */

        case 3:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 272; /* sne_sf_using_FCCmode */

        case 4:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 286; /* sne_df_using_FCCmode */

        default:
          return -1;
        }

    case GT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern29 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 239; /* *sgt_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 241; /* *sgt_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern30 (x2) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 243; /* *sgt_didi */

        case E_FCCmode:
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 274; /* sgt_sf_using_FCCmode */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 288; /* sgt_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern29 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 240; /* *sgtu_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 242; /* *sgtu_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern30 (x2) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 244; /* *sgtu_didi */

        default:
          return -1;
        }

    case GE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      switch (GET_CODE (x8))
        {
        case CONST_INT:
          if (XWINT (x8, 0) != 1L)
            return -1;
          switch (pattern7 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 245; /* *sge_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 247; /* *sge_disi */

            case 2:
              if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 249; /* *sge_didi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x8;
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 273; /* sge_sf_using_FCCmode */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 287; /* sge_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case GEU:
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (pattern7 (x2))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 246; /* *sgeu_sisi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 248; /* *sgeu_disi */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 250; /* *sgeu_didi */

        default:
          return -1;
        }

    case LT:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern31 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 251; /* *slt_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 253; /* *slt_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern32 (x2, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 255; /* *slt_didi */

        case E_FCCmode:
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 268; /* slt_sf_using_FCCmode */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 282; /* slt_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LTU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          switch (pattern31 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 252; /* *sltu_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 254; /* *sltu_disi */

            default:
              return -1;
            }

        case E_DImode:
          if (pattern32 (x2, E_DImode) != 0
              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 256; /* *sltu_didi */

        default:
          return -1;
        }

    case LE:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_CODE (operands[2]))
        {
        case CONST_INT:
          switch (pattern25 (x2))
            {
            case 0:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                return -1;
              return 257; /* *sle_sisi */

            case 1:
              if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 259; /* *sle_disi */

            case 2:
              if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 261; /* *sle_didi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern9 (x2))
            {
            case 0:
              if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 269; /* sle_sf_using_FCCmode */

            case 1:
              if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
                return -1;
              return 283; /* sle_df_using_FCCmode */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LEU:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (pattern25 (x2))
        {
        case 0:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
            return -1;
          return 258; /* *sleu_sisi */

        case 1:
          if (!
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 260; /* *sleu_disi */

        case 2:
          if (!
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          return 262; /* *sleu_didi */

        default:
          return -1;
        }

    case UNORDERED:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 263; /* sunordered_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 277; /* sunordered_df_using_FCCmode */

        default:
          return -1;
        }

    case UNEQ:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 264; /* suneq_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 278; /* suneq_df_using_FCCmode */

        default:
          return -1;
        }

    case UNLT:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 265; /* sunlt_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 279; /* sunlt_df_using_FCCmode */

        default:
          return -1;
        }

    case UNLE:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 266; /* sunle_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 280; /* sunle_df_using_FCCmode */

        default:
          return -1;
        }

    case ORDERED:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 270; /* sordered_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 284; /* sordered_df_using_FCCmode */

        default:
          return -1;
        }

    case LTGT:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 271; /* sltgt_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 285; /* sltgt_df_using_FCCmode */

        default:
          return -1;
        }

    case UNGE:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 275; /* sunge_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 289; /* sunge_df_using_FCCmode */

        default:
          return -1;
        }

    case UNGT:
      switch (pattern11 (x1))
        {
        case 0:
          if (!
#line 357 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 276; /* sungt_sf_using_FCCmode */

        case 1:
          if (!
#line 358 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT))
            return -1;
          return 290; /* sungt_df_using_FCCmode */

        default:
          return -1;
        }

    case CALL:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_SImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!call_insn_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      if (
#line 2909 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
        return 308; /* sibcall_value_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 311; /* call_value_internal */

    default:
      return -1;
    }
}

int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case TRAP_IF:
      x2 = XEXP (x1, 0);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      return 1; /* trap */

    case SET:
      return recog_20 (x1, insn, pnum_clobbers);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 0);
          switch (GET_CODE (x4))
            {
            case UNSPEC_VOLATILE:
              x5 = XVECEXP (x1, 0, 1);
              if (pattern14 (x5) != 0)
                return -1;
              switch (XVECLEN (x4, 0))
                {
                case 1:
                  if (GET_MODE (x4) != E_SImode)
                    return -1;
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  if (!const_uimm15_operand (operands[0], E_VOIDmode))
                    return -1;
                  switch (XINT (x4, 1))
                    {
                    case 2:
                      return 175; /* loongarch_ibar */

                    case 1:
                      return 176; /* loongarch_dbar */

                    case 18:
                      return 178; /* loongarch_syscall */

                    case 19:
                      return 179; /* loongarch_break */

                    default:
                      return -1;
                    }

                case 2:
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  x7 = XVECEXP (x4, 0, 1);
                  operands[1] = x7;
                  switch (XINT (x4, 1))
                    {
                    case 7:
                      if (!register_operand (operands[1], E_SImode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_QImode:
                          if (!register_operand (operands[0], E_QImode))
                            return -1;
                          return 192; /* loongarch_iocsrwr_b */

                        case E_HImode:
                          if (!register_operand (operands[0], E_HImode))
                            return -1;
                          return 193; /* loongarch_iocsrwr_h */

                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode))
                            return -1;
                          return 194; /* loongarch_iocsrwr_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !
#line 354 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 195; /* loongarch_iocsrwr_d */

                        default:
                          return -1;
                        }

                    case 10:
                      if (!const_uimm5_operand (operands[1], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 200; /* loongarch_ldpte_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 201; /* loongarch_ldpte_d */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 3:
                  x6 = XVECEXP (x4, 0, 0);
                  operands[0] = x6;
                  x7 = XVECEXP (x4, 0, 1);
                  operands[1] = x7;
                  x8 = XVECEXP (x4, 0, 2);
                  operands[2] = x8;
                  switch (XINT (x4, 1))
                    {
                    case 8:
                      if (!const_uimm5_operand (operands[0], E_VOIDmode)
                          || !const_imm12_operand (operands[2], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[1], E_SImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 196; /* loongarch_cacop_w */

                        case E_DImode:
                          if (!register_operand (operands[1], E_DImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 197; /* loongarch_cacop_d */

                        default:
                          return -1;
                        }

                    case 9:
                      if (!const_uimm5_operand (operands[2], E_VOIDmode))
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_SImode:
                          if (!register_operand (operands[0], E_SImode)
                              || !register_operand (operands[1], E_SImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(!TARGET_64BIT))
                            return -1;
                          return 198; /* loongarch_lddir_w */

                        case E_DImode:
                          if (!register_operand (operands[0], E_DImode)
                              || !register_operand (operands[1], E_DImode)
                              || !
#line 339 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 199; /* loongarch_lddir_d */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SET:
              return recog_19 (x1, insn, pnum_clobbers);

            case RETURN:
              x5 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x5))
                {
                case USE:
                  x9 = XEXP (x5, 0);
                  operands[0] = x9;
                  if (!pmode_register_operand (operands[0], E_VOIDmode))
                    return -1;
                  return 302; /* return_internal */

                case UNSPEC_VOLATILE:
                  if (XVECLEN (x5, 0) != 1
                      || XINT (x5, 1) != 11)
                    return -1;
                  x10 = XVECEXP (x5, 0, 0);
                  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return -1;
                  return 304; /* loongarch_ertn */

                default:
                  return -1;
                }

            case SIMPLE_RETURN:
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != USE)
                return -1;
              x9 = XEXP (x5, 0);
              operands[0] = x9;
              if (!pmode_register_operand (operands[0], E_VOIDmode))
                return -1;
              return 303; /* simple_return_internal */

            case UNSPEC:
              if (XVECLEN (x4, 0) != 1
                  || XINT (x4, 1) != 10)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x6 = XVECEXP (x4, 0, 0);
              operands[0] = x6;
              x9 = XEXP (x5, 0);
              operands[1] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode)
                      || !scratch_operand (operands[1], E_SImode)
                      || !
#line 2787 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
                    return -1;
                  return 305; /* eh_set_ra_si */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode)
                      || !scratch_operand (operands[1], E_DImode)
                      || !
#line 2793 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 306; /* eh_set_ra_di */

                default:
                  return -1;
                }

            case CALL:
              x11 = XEXP (x4, 0);
              if (GET_CODE (x11) != MEM
                  || GET_MODE (x11) != E_SImode)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x5) != CLOBBER)
                return -1;
              x9 = XEXP (x5, 0);
              if (GET_CODE (x9) != REG
                  || REGNO (x9) != 1
                  || GET_MODE (x9) != E_SImode)
                return -1;
              x12 = XEXP (x11, 0);
              operands[0] = x12;
              if (!call_insn_operand (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[1] = x13;
              return 310; /* call_internal */

            default:
              return -1;
            }

        case 3:
          x4 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x11 = XEXP (x4, 0);
          operands[0] = x11;
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case CALL:
              x15 = XEXP (x13, 0);
              if (GET_CODE (x15) != MEM
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x16 = XEXP (x5, 1);
              if (GET_CODE (x16) != CALL)
                return -1;
              x17 = XEXP (x16, 0);
              if (GET_CODE (x17) != MEM
                  || GET_MODE (x17) != E_SImode)
                return -1;
              x18 = XEXP (x14, 0);
              if (GET_CODE (x18) != REG
                  || REGNO (x18) != 1
                  || GET_MODE (x18) != E_SImode
                  || !register_operand (operands[0], E_VOIDmode))
                return -1;
              x19 = XEXP (x15, 0);
              operands[1] = x19;
              if (!call_insn_operand (operands[1], E_VOIDmode))
                return -1;
              x20 = XEXP (x13, 1);
              operands[2] = x20;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!register_operand (operands[3], E_VOIDmode))
                return -1;
              x21 = XEXP (x17, 0);
              if (!rtx_equal_p (x21, operands[1]))
                return -1;
              x22 = XEXP (x16, 1);
              if (!rtx_equal_p (x22, operands[2]))
                return -1;
              return 312; /* call_value_multiple_internal */

            case SUBREG:
            case MEM:
              operands[1] = x13;
              x16 = XEXP (x5, 1);
              if (GET_CODE (x16) != UNSPEC_VOLATILE)
                return -1;
              x9 = XEXP (x5, 0);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              switch (XVECLEN (x16, 0))
                {
                case 4:
                  if (XINT (x16, 1) != 22)
                    return -1;
                  x23 = XVECEXP (x16, 0, 0);
                  operands[2] = x23;
                  x24 = XVECEXP (x16, 0, 1);
                  operands[3] = x24;
                  x25 = XVECEXP (x16, 0, 2);
                  operands[4] = x25;
                  if (!const_int_operand (operands[4], E_SImode))
                    return -1;
                  x26 = XVECEXP (x16, 0, 3);
                  operands[5] = x26;
                  if (!const_int_operand (operands[5], E_SImode))
                    return -1;
                  x18 = XEXP (x14, 0);
                  operands[6] = x18;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern67 (x16, E_SImode) != 0)
                        return -1;
                      return 359; /* atomic_cas_value_strongsi */

                    case E_DImode:
                      if (pattern67 (x16, E_DImode) != 0
                          || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                        return -1;
                      return 360; /* atomic_cas_value_strongdi */

                    default:
                      return -1;
                    }

                case 5:
                  x23 = XVECEXP (x16, 0, 0);
                  operands[2] = x23;
                  x24 = XVECEXP (x16, 0, 1);
                  operands[3] = x24;
                  x25 = XVECEXP (x16, 0, 2);
                  operands[4] = x25;
                  x26 = XVECEXP (x16, 0, 3);
                  operands[5] = x26;
                  x27 = XVECEXP (x16, 0, 4);
                  operands[6] = x27;
                  if (!const_int_operand (operands[6], E_SImode))
                    return -1;
                  x18 = XEXP (x14, 0);
                  operands[7] = x18;
                  switch (XINT (x16, 1))
                    {
                    case 22:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern68 (x16, E_SImode) != 0)
                            return -1;
                          return 361; /* atomic_cas_value_cmp_and_7_si */

                        case E_DImode:
                          if (pattern68 (x16, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 362; /* atomic_cas_value_cmp_and_7_di */

                        default:
                          return -1;
                        }

                    case 30:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_SImode:
                          if (pattern68 (x16, E_SImode) != 0)
                            return -1;
                          return 375; /* atomic_cas_value_exchange_7_si */

                        case E_DImode:
                          if (pattern68 (x16, E_DImode) != 0
                              || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                            return -1;
                          return 376; /* atomic_cas_value_exchange_7_di */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 4:
          x4 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x4) != SET)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != SET)
            return -1;
          x16 = XEXP (x5, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 5)
            return -1;
          x14 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x14) != CLOBBER)
            return -1;
          x28 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x28) != CLOBBER)
            return -1;
          x11 = XEXP (x4, 0);
          operands[0] = x11;
          x13 = XEXP (x4, 1);
          operands[1] = x13;
          x23 = XVECEXP (x16, 0, 0);
          operands[2] = x23;
          x24 = XVECEXP (x16, 0, 1);
          operands[3] = x24;
          x25 = XVECEXP (x16, 0, 2);
          operands[4] = x25;
          x26 = XVECEXP (x16, 0, 3);
          operands[5] = x26;
          x27 = XVECEXP (x16, 0, 4);
          operands[6] = x27;
          if (!const_int_operand (operands[6], E_SImode))
            return -1;
          x18 = XEXP (x14, 0);
          operands[7] = x18;
          x29 = XEXP (x28, 0);
          operands[8] = x29;
          x9 = XEXP (x5, 0);
          if (!rtx_equal_p (x9, operands[1]))
            return -1;
          switch (XINT (x16, 1))
            {
            case 23:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 363; /* atomic_cas_value_add_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 364; /* atomic_cas_value_add_7_di */

                default:
                  return -1;
                }

            case 24:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 365; /* atomic_cas_value_sub_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 366; /* atomic_cas_value_sub_7_di */

                default:
                  return -1;
                }

            case 25:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 367; /* atomic_cas_value_and_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 368; /* atomic_cas_value_and_7_di */

                default:
                  return -1;
                }

            case 26:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 369; /* atomic_cas_value_xor_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 370; /* atomic_cas_value_xor_7_di */

                default:
                  return -1;
                }

            case 27:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 371; /* atomic_cas_value_or_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 372; /* atomic_cas_value_or_7_di */

                default:
                  return -1;
                }

            case 28:
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (pattern69 (x16, E_SImode) != 0)
                    return -1;
                  return 373; /* atomic_cas_value_nand_7_si */

                case E_DImode:
                  if (pattern69 (x16, E_DImode) != 0
                      || !
#line 321 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                    return -1;
                  return 374; /* atomic_cas_value_nand_7_di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x4 = XVECEXP (x1, 0, 0);
          operands[0] = x4;
          x5 = XVECEXP (x1, 0, 1);
          operands[1] = x5;
          switch (XINT (x1, 1))
            {
            case 16:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2103 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 180; /* loongarch_asrtle_d */

            case 17:
              if (GET_MODE (x1) != E_DImode
                  || !register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !
#line 2112 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
                return -1;
              return 181; /* loongarch_asrtgt_d */

            case 14:
              if (!const_uimm5_operand (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_SImode)
                  || !
#line 3234 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT))
                return -1;
              return 315; /* loongarch_movgr2fcsr */

            default:
              return -1;
            }

        case 1:
          if (XINT (x1, 1) != 0)
            return -1;
          x4 = XVECEXP (x1, 0, 0);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 297; /* blockage */

        default:
          return -1;
        }

    case RETURN:
      return 300; /* *return */

    case SIMPLE_RETURN:
      return 301; /* *simple_return */

    case UNSPEC:
      if (pnum_clobbers == NULL
          || XVECLEN (x1, 0) != 1
          || XINT (x1, 1) != 10)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2787 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(! TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 305; /* eh_set_ra_si */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || !
#line 2793 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT))
            return -1;
          *pnum_clobbers = 1;
          return 306; /* eh_set_ra_di */

        default:
          return -1;
        }

    case CALL:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != MEM
          || GET_MODE (x2) != E_SImode)
        return -1;
      x30 = XEXP (x2, 0);
      operands[0] = x30;
      if (!call_insn_operand (operands[0], E_VOIDmode))
        return -1;
      x3 = XEXP (x1, 1);
      operands[1] = x3;
      if (
#line 2833 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(SIBLING_CALL_P (insn)))
        return 307; /* sibcall_internal */
      if (pnum_clobbers == NULL)
        return -1;
      *pnum_clobbers = 1;
      return 310; /* call_internal */

    case CONST_INT:
      if (XWINT (x1, 0) != 0L)
        return -1;
      return 313; /* nop */

    default:
      return -1;
    }
}

rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 0);
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (GET_CODE (x3))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x3) == E_DImode
              && register_operand (operands[0], E_DImode))
            {
              x4 = XEXP (x3, 0);
              operands[1] = x4;
              if (nonimmediate_operand (operands[1], E_SImode)
                  && (
#line 1154 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_64BIT) && 
#line 1160 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
( reload_completed
   && MEM_P (operands[1])
   && (loongarch_14bit_shifted_offset_address_p (XEXP (operands[1], 0), SImode)
       && !loongarch_12bit_offset_address_p (XEXP (operands[1], 0), SImode))
   && !paradoxical_subreg_p (operands[0]))))
                return gen_split_1 (insn, operands);
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[1] = x3;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (nonimmediate_operand (operands[0], E_DImode)
                  && move_operand (operands[1], E_DImode)
                  && 
#line 1780 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed && loongarch_split_move_insn_p (operands[0], operands[1])))
                return gen_split_2 (insn, operands);
              break;

            case E_DFmode:
              if (nonimmediate_operand (operands[0], E_DFmode)
                  && move_operand (operands[1], E_DFmode)
                  && 
#line 1780 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed && loongarch_split_move_insn_p (operands[0], operands[1])))
                return gen_split_3 (insn, operands);
              break;

            case E_TImode:
              if (nonimmediate_operand (operands[0], E_TImode)
                  && move_operand (operands[1], E_TImode)
                  && 
#line 1790 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed && loongarch_split_move_insn_p (operands[0], operands[1])))
                return gen_split_4 (insn, operands);
              break;

            case E_TFmode:
              if (nonimmediate_operand (operands[0], E_TFmode)
                  && move_operand (operands[1], E_TFmode)
                  && 
#line 1790 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed && loongarch_split_move_insn_p (operands[0], operands[1])))
                return gen_split_5 (insn, operands);
              break;

            default:
              break;
            }
          break;

        case BSWAP:
          x4 = XEXP (x3, 0);
          operands[1] = x4;
          switch (pattern4 (x3))
            {
            case 0:
              return gen_split_6 (insn, operands);

            case 1:
              return gen_split_7 (insn, operands);

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case PARALLEL:
      if (XVECLEN (x1, 0) == 2)
        {
          x5 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x5) == UNSPEC
              && XVECLEN (x5, 0) == 1
              && XINT (x5, 1) == 10)
            {
              x6 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x6) == CLOBBER)
                {
                  x7 = XVECEXP (x5, 0, 0);
                  operands[0] = x7;
                  if (register_operand (operands[0], E_VOIDmode))
                    {
                      x8 = XEXP (x6, 0);
                      operands[1] = x8;
                      if (scratch_operand (operands[1], E_VOIDmode)
                          && 
#line 2799 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
                        return gen_split_8 (insn, operands);
                    }
                }
            }
        }
      break;

    default:
      break;
    }
  operands[0] = x1;
  if (!small_data_pattern (operands[0], E_VOIDmode)
      || !
#line 3297 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(reload_completed))
    return NULL;
  return gen_split_9 (insn, operands);
}

rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (peep2_current_count < 2
      || GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  if (GET_CODE (x3) != SET)
    return NULL;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (register_operand (operands[0], E_HImode)
              && non_volatile_mem_operand (operands[1], E_HImode)
              && register_operand (operands[2], E_HImode)
              && non_volatile_mem_operand (operands[3], E_HImode)
              && 
#line 3330 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_HImode)
              || !register_operand (operands[1], E_HImode)
              || !memory_operand (operands[2], E_HImode)
              || !register_operand (operands[3], E_HImode)
              || !
#line 3343 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        case E_SImode:
          if (register_operand (operands[0], E_SImode)
              && non_volatile_mem_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_SImode)
              && non_volatile_mem_operand (operands[3], E_SImode)
              && 
#line 3330 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_SImode)
              || !register_operand (operands[1], E_SImode)
              || !memory_operand (operands[2], E_SImode)
              || !register_operand (operands[3], E_SImode)
              || !
#line 3343 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SImode, false)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_6 (insn, operands);

        case E_SFmode:
          if (register_operand (operands[0], E_SFmode)
              && non_volatile_mem_operand (operands[1], E_SFmode)
              && register_operand (operands[2], E_SFmode)
              && non_volatile_mem_operand (operands[3], E_SFmode)
              && (
#line 3330 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, true)) && 
#line 331 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_3 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_SFmode)
              || !register_operand (operands[1], E_SFmode)
              || !memory_operand (operands[2], E_SFmode)
              || !register_operand (operands[3], E_SFmode)
              || !(
#line 3343 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, SFmode, false)) && 
#line 331 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_HARD_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_7 (insn, operands);

        case E_DFmode:
          if (register_operand (operands[0], E_DFmode)
              && non_volatile_mem_operand (operands[1], E_DFmode)
              && register_operand (operands[2], E_DFmode)
              && non_volatile_mem_operand (operands[3], E_DFmode)
              && (
#line 3330 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, true)) && 
#line 332 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_4 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!memory_operand (operands[0], E_DFmode)
              || !register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[2], E_DFmode)
              || !register_operand (operands[3], E_DFmode)
              || !(
#line 3343 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, DFmode, false)) && 
#line 332 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(TARGET_DOUBLE_FLOAT)))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      if (pattern34 (x5, SIGN_EXTEND) != 0
          || !
#line 3375 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_9 (insn, operands);

    case ZERO_EXTEND:
      if (pattern34 (x5, ZERO_EXTEND) != 0
          || !
#line 3375 "../../gcc-12.2.1-20221121/gcc/config/loongarch/loongarch.md"
(loongarch_load_store_bonding_p (operands, HImode, true)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_10 (insn, operands);

    default:
      return NULL;
    }
}
